import requests
import json

        
def make_api_request(api_token, endpoint, xml_file_path):
    global send_mail
    mail_str = ""
    # Set the API endpoint
    url = f"https://mis.cdon.com/{endpoint}"

    # Set the Authorization header with the API Token
    headers = {
        "Authorization": f"api {api_token}",
        "Content-Type": "application/xml"  # Set the content type for XML
    }

    try:
        # Read the content of the XML file
        with open(xml_file_path, 'rb') as file:
            xml_content = file.read()

        # Make the API request with the XML content
        response = requests.post(url, headers=headers, data=xml_content)

        # Check for successful response (status code 2xx)
        if response.status_code // 100 == 2:
            print(f"{xml_file_path} Request successful!")
            print(f"{xml_file_path} Response:", response.text)
        else:
            print(f"{xml_file_path} Request failed with status code {response.status_code}")
            print(f"{xml_file_path} Response:", response.text)
        mail_str += f"{xml_file_path} " + response.text + '\n'
        headers['Content-Type'] = 'application/json'
        r = requests.get(json.loads(response.text)['statusUrl'], headers=headers)
        print(r.text)
        try:
            if int(json.loads(r.text)['Code']) // 100 != 2:
                mail_str += f"{xml_file_path} " + r.text+'\n'
                print(r.text)
                send_mail = True
        except:
            pass

    except requests.RequestException as e:
        print(f"Request error: {e}")
    return mail_str

def execute():
    mail_str = ""
    prices_to_send = ['feeds/prices.xml']
    stocks_to_send = ['feeds/stocks.xml']
    api_token = 'a71240b9-298d-4a14-859b-e5907c313605'
    for xml_file_path in prices_to_send:
        mail_str += make_api_request(api_token, 'price', xml_file_path)
    for xml_file_path in stocks_to_send:
        mail_str += make_api_request(api_token, 'availability', xml_file_path)
    
if __name__ == "__main__":
    execute()